[packages] quagga{,-unstable}: Add package maintainer
[openwrt/svn-archive/archive.git] / net / quagga / Makefile
index eb733bcbef6e091d653f864fe59423646dee8e02..3f592d6ad9ce2a24cb4eb26c2c3d0f0d5d9e35db 100644 (file)
 #
 #
-# Copyright (C) 2006 OpenWrt.org
+# Copyright (C) 2006-2010 OpenWrt.org
 #
 # This is free software, licensed under the GNU General Public License v2.
 # See /LICENSE for more information.
 #
 #
 # This is free software, licensed under the GNU General Public License v2.
 # See /LICENSE for more information.
 #
-# $Id$
 
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=quagga
 PKG_VERSION:=0.98.6
 
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=quagga
 PKG_VERSION:=0.98.6
-PKG_RELEASE:=1
+PKG_RELEASE:=5
 PKG_MD5SUM:=b0d4132039953a0214256873b7d23d68
 
 PKG_SOURCE_URL:=http://www.quagga.net/download/ \
                 http://www.de.quagga.net/download/ \
                 http://www.uk.quagga.net/download/
 PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
 PKG_MD5SUM:=b0d4132039953a0214256873b7d23d68
 
 PKG_SOURCE_URL:=http://www.quagga.net/download/ \
                 http://www.de.quagga.net/download/ \
                 http://www.uk.quagga.net/download/
 PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
-PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)
-PKG_CAT:=zcat
 
 
-PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)
-PKG_INSTALL_DIR:=$(PKG_BUILD_DIR)/ipkg-install
+PKG_CONFIG_DEPENDS:= \
+       CONFIG_PACKAGE_quagga-unstable-isisd \
+       CONFIG_PACKAGE_quagga-unstable-ripngd
+
+PKG_FIXUP:=libtool
 
 include $(INCLUDE_DIR)/package.mk
 
 
 include $(INCLUDE_DIR)/package.mk
 
-define Package/quagga
+define Package/quagga/Default
   SECTION:=net
   CATEGORY:=Network
   SECTION:=net
   CATEGORY:=Network
+  DEPENDS:=quagga
   TITLE:=The Quagga Software Routing Suite
   TITLE:=The Quagga Software Routing Suite
-  DESCRIPTION:=A routing software package that provides TCP/IP based routing services\\\
-       with routing protocols support such as RIPv1, RIPv2, RIPng, OSPFv2,\\\
-       OSPFv3, BGP-4, and BGP-4+\\\
   URL:=http://www.quagga.net
   URL:=http://www.quagga.net
+  MAINTAINER:=Vasilis Tsiligiannis <b_tsiligiannis@silverton.gr>
+endef
+
+define Package/quagga
+  $(call Package/quagga/Default)
+  DEPENDS:=
   MENU:=1
 endef
 
   MENU:=1
 endef
 
+define Package/quagga/description
+  A routing software package that provides TCP/IP based routing services
+  with routing protocols support such as RIPv1, RIPv2, RIPng, OSPFv2,
+  OSPFv3, BGP-4, and BGP-4+
+endef
+
 define Package/quagga-libzebra
 define Package/quagga-libzebra
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga
+  $(call Package/quagga/Default)
   TITLE:=zebra library
 endef
 
 define Package/quagga-libospf
   TITLE:=zebra library
 endef
 
 define Package/quagga-libospf
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga
+  $(call Package/quagga/Default)
   TITLE:=OSPF library
 endef
 
 define Package/quagga-bgpd
   TITLE:=OSPF library
 endef
 
 define Package/quagga-bgpd
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga
+  $(call Package/quagga/Default)
+  DEPENDS += quagga-libzebra
   TITLE:=BGPv4, BGPv4+, BGPv4- routing engine
 endef
 
 define Package/quagga-isisd
   TITLE:=BGPv4, BGPv4+, BGPv4- routing engine
 endef
 
 define Package/quagga-isisd
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga
+  $(call Package/quagga/Default)
   TITLE:=IS-IS routing engine
 endef
 
 define Package/quagga-ospfd
   TITLE:=IS-IS routing engine
 endef
 
 define Package/quagga-ospfd
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga quagga-libospf
+  $(call Package/quagga/Default)
+  DEPENDS += quagga-libospf quagga-libzebra
   TITLE:=OSPFv2 routing engine
 endef
 
 define Package/quagga-ospf6d
   TITLE:=OSPFv2 routing engine
 endef
 
 define Package/quagga-ospf6d
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga quagga-libospf
+  $(call Package/quagga/Default)
+  DEPENDS += quagga-libospf quagga-libzebra @IPV6
   TITLE:=OSPFv3 routing engine
 endef
 
 define Package/quagga-ripd
   TITLE:=OSPFv3 routing engine
 endef
 
 define Package/quagga-ripd
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga
+  $(call Package/quagga/Default)
+  DEPENDS += quagga-libzebra
   TITLE:=RIP routing engine
 endef
 
 define Package/quagga-ripngd
   TITLE:=RIP routing engine
 endef
 
 define Package/quagga-ripngd
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga
+  $(call Package/quagga/Default)
+  DEPENDS += quagga-libzebra @BROKEN
   TITLE:=RIPNG routing engine
 endef
 
 define Package/quagga-vtysh
   TITLE:=RIPNG routing engine
 endef
 
 define Package/quagga-vtysh
-  SECTION:=net
-  CATEGORY:=Network
-  DEPENDS:=quagga +libreadline +libncurses
+  $(call Package/quagga/Default)
+  DEPENDS += quagga-libzebra +libreadline +libncurses
   TITLE:=integrated shell for Quagga routing software
 endef
 
   TITLE:=integrated shell for Quagga routing software
 endef
 
-define Build/Configure
-$(call Build/Configure/Default, --enable-shared \
-               --disable-static \
-               --enable-ipv6 \
-               --enable-vtysh \
-               --enable-user=quagga \
-               --enable-group=quagga \
-               --enable-multipath=8 \
-               --enable-isisd)
+define Package/quagga/conffiles
+/etc/quagga/zebra.conf
+endef
+
+define Package/quagga-bgpd/conffiles
+/etc/quagga/bgpd.conf
+endef
+
+define Package/quagga-isisd/conffiles
+/etc/quagga/isisd.conf
+endef
+
+define Package/quagga-ospfd/conffiles
+/etc/quagga/ospfd.conf
+endef
+
+define Package/quagga-ospf6d/conffiles
+/etc/quagga/ospf6d.conf
+endef
+
+define Package/quagga-ripd/conffiles
+/etc/quagga/ripd.conf
 endef
 
 endef
 
-define Build/Compile   
+define Package/quagga-ripngd/conffiles
+/etc/quagga/ripngd.conf
+endef
+
+CONFIGURE_ARGS+= \
+       --localstatedir=/var/run/quagga \
+       --sysconfdir=/etc/quagga/ \
+       --enable-shared \
+       --disable-static \
+       --enable-vtysh \
+       --enable-user=quagga \
+       --enable-group=quagga \
+       --enable-multipath=8 \
+
+ifneq ($(CONFIG_PACKAGE_quagga-isisd),)
+  CONFIGURE_ARGS+= --enable-isisd
+endif
+
+ifneq ($(CONFIG_PACKAGE_quagga-ripngd),)
+  CONFIGURE_ARGS+= --enable-ripngd
+endif
+
+define Build/Compile
        $(MAKE) -C $(PKG_BUILD_DIR) \
                DESTDIR=$(PKG_INSTALL_DIR) \
                all install
 endef
 
        $(MAKE) -C $(PKG_BUILD_DIR) \
                DESTDIR=$(PKG_INSTALL_DIR) \
                all install
 endef
 
-define Package/quagga/install  
-       install -d -m0755 $(1)/usr/sbin
-       $(CP) $(PKG_INSTALL_DIR)/usr/sbin/zebra $(1)/usr/sbin/
-       $(CP) $(PKG_INSTALL_DIR)/usr/sbin/watchquagga $(1)/usr/sbin/
+define Package/quagga/install
+       $(INSTALL_DIR) $(1)/usr/sbin
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/zebra $(1)/usr/sbin/
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/watchquagga $(1)/usr/sbin/
        # avoid /etc being set to 0750
        # avoid /etc being set to 0750
-       install -d -m0755 $(1)/etc/quagga/
-       chmod 0750 $(1)/etc/quagga/
-       install -d -m0755 $(1)/etc/init.d/
-       install -m0755 ./files/quagga.init $(1)/etc/init.d/quagga
-       ln -sf quagga $(1)/etc/init.d/S49quagga
-       install -d -m0755 $(1)/var/run/quagga
+       $(INSTALL_DIR) $(1)/etc/quagga
+       chmod 0750 $(1)/etc/quagga
+       $(INSTALL_CONF) ./files/quagga.conf $(1)/etc/quagga/zebra.conf
+       $(INSTALL_DIR) $(1)/etc/init.d
+       $(INSTALL_BIN) ./files/quagga $(1)/usr/sbin/quagga.init
+       $(INSTALL_BIN) ./files/quagga.init $(1)/etc/init.d/quagga
 endef
 
 endef
 
-define Package/quagga-bgpd/install     
-       install -d -m0755 $(1)/usr/sbin
-       $(CP) $(PKG_INSTALL_DIR)/usr/sbin/bgpd $(1)/usr/sbin/
+define Package/quagga/postinst
+#!/bin/sh
+
+name=quagga
+id=51
+
+# do not change below
+# check if we are on real system
+if [ -z "$${IPKG_INSTROOT}" ]; then
+       # create copies of passwd and group, if we use squashfs
+       rootfs=`mount |awk '/root/ { print $$5 }'`
+       if [ "$$rootfs" = "squashfs" ]; then
+               if [ -h /etc/group ]; then
+                       rm /etc/group
+                       cp /rom/etc/group /etc/group
+               fi
+               if [ -h /etc/passwd ]; then
+                       rm /etc/passwd
+                       cp /rom/etc/passwd /etc/passwd
+               fi
+       fi
+fi
+
+echo ""
+if [ -z "$$(grep ^\\$${name}: $${IPKG_INSTROOT}/etc/group)" ]; then
+       echo "adding group $$name to /etc/group"
+       echo "$${name}:x:$${id}:" >> $${IPKG_INSTROOT}/etc/group
+fi
+
+if [ -z "$$(grep ^\\$${name}: $${IPKG_INSTROOT}/etc/passwd)" ]; then
+       echo "adding user $$name to /etc/passwd"
+       echo "$${name}:x:$${id}:$${id}:$${name}:/tmp/.$${name}:/bin/false" >> $${IPKG_INSTROOT}/etc/passwd
+fi
+
+grep -q '^zebra[[:space:]]*2601/tcp' $${IPKG_INSTROOT}/etc/services 2>/dev/null
+if [ $$? -ne 0 ]; then
+echo "zebrasrv      2600/tcp" >>$${IPKG_INSTROOT}/etc/services
+echo "zebra         2601/tcp" >>$${IPKG_INSTROOT}/etc/services
+echo "ripd          2602/tcp" >>$${IPKG_INSTROOT}/etc/services
+echo "ripngd        2603/tcp" >>$${IPKG_INSTROOT}/etc/services
+echo "ospfd         2604/tcp" >>$${IPKG_INSTROOT}/etc/services
+echo "bgpd          2605/tcp" >>$${IPKG_INSTROOT}/etc/services
+echo "ospf6d        2606/tcp" >>$${IPKG_INSTROOT}/etc/services
+echo "ospfapi       2607/tcp" >>$${IPKG_INSTROOT}/etc/services
+echo "isisd         2608/tcp" >>$${IPKG_INSTROOT}/etc/services
+fi
+endef
+
+define Package/quagga-bgpd/install
+       $(INSTALL_DIR) $(1)/usr/sbin
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/bgpd $(1)/usr/sbin/
+       $(INSTALL_DIR) $(1)/etc/quagga
+       chmod 0750 $(1)/etc/quagga
+       $(INSTALL_CONF) ./files/quagga.conf $(1)/etc/quagga/bgpd.conf
 endef
 
 define Package/quagga-isisd/install
 endef
 
 define Package/quagga-isisd/install
-       install -d -m0755 $(1)/usr/sbin
-       $(CP) $(PKG_INSTALL_DIR)/usr/sbin/isisd $(1)/usr/sbin
+       $(INSTALL_DIR) $(1)/usr/sbin
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/isisd $(1)/usr/sbin/
+       $(INSTALL_DIR) $(1)/etc/quagga
+       chmod 0750 $(1)/etc/quagga
+       $(INSTALL_CONF) ./files/quagga.conf $(1)/etc/quagga/isisd.conf
 endef
 
 endef
 
-define Package/quagga-ospfd/install    
-       install -d -m0755 $(1)/usr/lib
-       $(CP) $(PKG_INSTALL_DIR)/usr/lib/libospf.so.* $(1)/usr/lib/
-       install -d -m0755 $(1)/usr/sbin
-       $(CP) $(PKG_INSTALL_DIR)/usr/sbin/ospfd $(1)/usr/sbin/
+define Package/quagga-ospfd/install
+       $(INSTALL_DIR) $(1)/usr/sbin
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/ospfd $(1)/usr/sbin/
+       $(INSTALL_DIR) $(1)/etc/quagga
+       chmod 0750 $(1)/etc/quagga
+       $(INSTALL_CONF) ./files/quagga.conf $(1)/etc/quagga/ospfd.conf
 endef
 
 endef
 
-define Package/quagga-ospf6d/install   
-       install -d -m0755 $(1)/usr/sbin
-       $(CP) $(PKG_INSTALL_DIR)/usr/sbin/ospf6d $(1)/usr/sbin/
+define Package/quagga-ospf6d/install
+       $(INSTALL_DIR) $(1)/usr/sbin
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/ospf6d $(1)/usr/sbin/
+       $(INSTALL_DIR) $(1)/etc/quagga
+       chmod 0750 $(1)/etc/quagga
+       $(INSTALL_CONF) ./files/quagga.conf $(1)/etc/quagga/ospf6d.conf
 endef
 
 endef
 
-define Package/quagga-ripd/install     
-       install -d -m0755 $(1)/usr/sbin
-       $(CP) $(PKG_INSTALL_DIR)/usr/sbin/ripd $(1)/usr/sbin/
+define Package/quagga-ripd/install
+       $(INSTALL_DIR) $(1)/usr/sbin
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/ripd $(1)/usr/sbin/
+       $(INSTALL_DIR) $(1)/etc/quagga
+       chmod 0750 $(1)/etc/quagga
+       $(INSTALL_CONF) ./files/quagga.conf $(1)/etc/quagga/ripd.conf
 endef
 
 endef
 
-define Package/quagga-ripngd/install   
-       install -d -m0755 $(1)/usr/sbin
-       $(CP) $(PKG_INSTALL_DIR)/usr/sbin/ripngd $(1)/usr/sbin/
+define Package/quagga-ripngd/install
+       $(INSTALL_DIR) $(1)/usr/sbin
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/ripngd $(1)/usr/sbin/
+       $(INSTALL_DIR) $(1)/etc/quagga
+       chmod 0750 $(1)/etc/quagga
+       $(INSTALL_CONF) ./files/quagga.conf $(1)/etc/quagga/ripngd.conf
 endef
 
 endef
 
-define Package/quagga-vtysh/install    
-       install -d -m0755 $(1)/usr/bin
-       $(CP) $(PKG_INSTALL_DIR)/usr/bin/vtysh $(1)/usr/bin/
+define Package/quagga-vtysh/install
+       $(INSTALL_DIR) $(1)/usr/bin
+       $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/vtysh $(1)/usr/bin/
 endef
 
 define Package/quagga-libospf/install
 endef
 
 define Package/quagga-libospf/install
-       install -d -m0755 $(1)/usr/lib
+       $(INSTALL_DIR) $(1)/usr/lib
        $(CP) $(PKG_INSTALL_DIR)/usr/lib/libospf.so.* $(1)/usr/lib/
 endef
 
 define Package/quagga-libzebra/install
        $(CP) $(PKG_INSTALL_DIR)/usr/lib/libospf.so.* $(1)/usr/lib/
 endef
 
 define Package/quagga-libzebra/install
-       install -d -m0755 $(1)/usr/lib
-       $(CP) $(PKG_INSTALL_DIR)/usr/lib/libzebra.so.* $(1)/usr/lib
+       $(INSTALL_DIR) $(1)/usr/lib
+       $(CP) $(PKG_INSTALL_DIR)/usr/lib/libzebra.so.* $(1)/usr/lib/
 endef
 
 $(eval $(call BuildPackage,quagga))
 endef
 
 $(eval $(call BuildPackage,quagga))